import csv
from math import sqrt
csvfile=open('movie-ratings.csv')
reading=list(csv.reader(csvfile))
#########################
f2 = open ("user_preference.csv")
user_data = csv.reader(f2)
preference = []
preference.append(input("Your name :"))
for line in user_data:
    preference.append(line)
prefdict = dict( zip(preference[1],preference[2]))
####################
header = reading[0]
del reading[0]
reviewers = [ s[0] for s in reading]
reviewdic = []
for line in reading:
    dic = dict( (header[i],line[i]) for i in range(1,len(line)))
    reviewdic.append(dic)
dist=[]
for i in reviewdic:
    sum1=0
    euclid_temp=[sqrt((float(i[j])-float(prefdict[j]))**2) for j in prefdict.keys() if float(i[j])!=-1 and float(prefdict[j])!=-1]
    dist.append(sum(euclid_temp)/len(euclid_temp))
order_dist = sorted(zip(reviewers,dist), key=lambda x: x[1],reverse=True)
#############################################
temp_movieUser=[i for i in prefdict.keys() if float(prefdict[i])!=-1]
pear=[]
for i in reviewdic:
    temp_movieRev=[j for j in prefdict.keys() if float(i[j])!=-1]
    var=list(set(temp_movieUser).intersection(temp_movieRev))
    temp=[float(i[j]) for j in var if float(i[j])!=-1]
    temp1=[float(prefdict[j]) for j in var if float(prefdict[j])!=-1]
    mean=sum(temp)/len(temp)
    avgUser=sum(temp1)/len(temp1)
    stdUser=sqrt((sum(map(lambda x: x*x,temp1))/len(temp1))-avgUser)
    stdRev=sqrt((sum(map(lambda x: x*x,temp))/len(temp))-mean)
    pear.append(sum([(float(prefdict[j])-avgUser)*(float(i[j])-mean)/(len(var)*stdRev*stdUser) for j in var]))
order_pear=sorted(zip(reviewers,pear), key=lambda x:x[1], reverse=True)
unwatched_movies=[i for i in prefdict.keys() if float(prefdict[i])==-1]
finalrating = {}
for movie in header[1:]:
    var=[pear[i]*float(reviewdic[i][movie]) for i in range(len(pear)) if float(reviewdic[i][movie])!=-1 and float(prefdict[movie])!=-1]
    finalrating[movie]=sum(var)
finalorder = sorted(finalrating.items(), key=lambda x: x[1], reverse = True)
towatch = []
for movie,rating in finalorder:
    if movie not in unwatched_movies:
        continue
    else:
        towatch.append(movie)
if len(towatch)>=3:
    for i in range(3):
        print (towatch[i])
else:
    for movie,rating in finalorder:
        print (movie)
